Bug 1378393 - Devices created after a checkpoint are not removed upon rollback
Summary: Devices created after a checkpoint are not removed upon rollback
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: NetworkManager
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Beniamino Galvani
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-09-22 10:35 UTC by Marius Vollmer
Modified: 2017-12-12 10:09 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-12 10:09:33 UTC


Attachments (Terms of Use)
[PATCH] checkpoint: introduce new flags to better restore previous state (10.08 KB, patch)
2016-09-24 08:33 UTC, Beniamino Galvani
no flags Details | Diff

Description Marius Vollmer 2016-09-22 10:35:02 UTC
Description of problem:

Creating a virtual device like a bond is not undone when rolling back a checkpoint that has been taken "for all devices".

Version-Release number of selected component (if applicable):
NetworkManager-1.4.0-4.fc25.x86_64

How reproducible:
Always

Steps to Reproduce:
I couldn't find a way to create checkpoints with nmcli.  But here's a video of Cockpit:

  https://www.youtube.com/watch?v=x0tYVrgXKWo

- Create a team with the main network interface as a member.
- Cockpit takes a checkpoint before this with devices = [ ], meaning all managed devices.
- The team starts out as Inactive and Cockpit rolls back the checkpoint.

Actual results:
The main interface is no longer a member of the team and has its old configuration back, but the team still exists.


Expected results:
The team is removed.

Comment 1 Beniamino Galvani 2016-09-24 08:33:11 UTC
Created attachment 1204335 [details]
[PATCH] checkpoint: introduce new flags to better restore previous state

Preliminary patch; other ideas and suggestions are welcome.

Comment 2 Thomas Haller 2016-09-26 14:20:02 UTC
+                              "the REMOVE_NEW_DEVS flag can only be used with an empty device list");

write the name of the flag in the API: DISCONNECT_NEW_DEVICES



otherwise, lgtm as is

Comment 3 Beniamino Galvani 2016-10-24 08:05:19 UTC
(In reply to Thomas Haller from comment #2)
> +                              "the REMOVE_NEW_DEVS flag can only be used
> with an empty device list");
> 
> write the name of the flag in the API: DISCONNECT_NEW_DEVICES

Fixed and applied:

https://cgit.freedesktop.org/NetworkManager/NetworkManager/commit/?id=ddeef464af9a565e6b6ca7a6470a7ee588079739

Comment 4 Marius Vollmer 2017-04-11 06:04:38 UTC
This still happens with NM 1.8.

Comment 5 Beniamino Galvani 2017-04-11 08:33:59 UTC
(In reply to Marius Vollmer from comment #4)
> This still happens with NM 1.8.

We have added two new flags DELETE_NEW_CONNECTIONS and DISCONNECT_NEW_DEVICES that should be passed to CheckpointCreate() to achieve the behavior you want:

  https://cgit.freedesktop.org/NetworkManager/NetworkManager/tree/libnm-core/nm-dbus-interface.h#n823

Did you try such flags?

Comment 6 Marius Vollmer 2017-04-11 10:44:54 UTC
(In reply to Beniamino Galvani from comment #5)
> (In reply to Marius Vollmer from comment #4)
> > This still happens with NM 1.8.
> 
> We have added two new flags DELETE_NEW_CONNECTIONS and
> DISCONNECT_NEW_DEVICES that should be passed to CheckpointCreate() to
> achieve the behavior you want:
> 
>  
> https://cgit.freedesktop.org/NetworkManager/NetworkManager/tree/libnm-core/
> nm-dbus-interface.h#n823
> 
> Did you try such flags?

Ahh.  No, I misunderstood the significance of the flags.  I thought they are some internal mechanism only.

I'll start using the flags.  Any downside to just always setting them?

Comment 7 Beniamino Galvani 2017-04-11 11:45:46 UTC
(In reply to Marius Vollmer from comment #6)
> (In reply to Beniamino Galvani from comment #5)
> > (In reply to Marius Vollmer from comment #4)
> > > This still happens with NM 1.8.
> > 
> > We have added two new flags DELETE_NEW_CONNECTIONS and
> > DISCONNECT_NEW_DEVICES that should be passed to CheckpointCreate() to
> > achieve the behavior you want:
> > 
> >  
> > https://cgit.freedesktop.org/NetworkManager/NetworkManager/tree/libnm-core/
> > nm-dbus-interface.h#n823
> > 
> > Did you try such flags?
> 
> Ahh.  No, I misunderstood the significance of the flags.  I thought they are
> some internal mechanism only.
> 
> I'll start using the flags.  Any downside to just always setting them?

No, the only effect is that connections added after the checkpoint will be deleted on rollback, and new devices will be disconnected. These flags are ignored by previous NM versions, so should be safe to use everywhere.

Comment 8 Fedora End Of Life 2017-11-16 19:35:12 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 9 Fedora End Of Life 2017-12-12 10:09:33 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.